/* Desenha e renderiza um circulo (apenas com driver de usuario) */


#include <graphics.h>
#include <conio.h>        // getch
#include <math.h>         // sqrt


int huge Detect ()
{
	return ( 2 );
}


int Quadrado ( int N )
{
	return ( N * N );
}


int Delta ( int X, int Y )
{
	return ( 2500 - Quadrado ( X ) - Quadrado ( Y ) );
}


int CalcZ ( int X, int Y )
{
	return ( sqrt ( Delta ( X, Y ) ) );
}


main ()
{
	int
		ContaX,
		ContaY,
		GrDriver = DETECT,
		GrMode;

	installuserdriver ( "svga256", Detect );
	initgraph (&GrDriver, &GrMode, "");
	setgraphmode ( 2 );


	//Altera palheta (de 64 a 64+64 estao 64 tons de azul).
	for ( int Conta = 0; Conta < 64; Conta ++ )
		setrgbpalette (Conta + 64, 0, 0, Conta);

	// Desenha circulo
	for ( ContaY = -50; ContaY < 50; ContaY ++ )
		for ( ContaX = -50; ContaX < 50; ContaX ++ )
			{
				if ( Delta ( ContaX, ContaY ) >= 0 )
					putpixel ( ContaX + 320, ContaY + 240, BLUE );
			}

	getch ();

	// Renderiza
	int
		Cor,
		CVetN_X,            // componentes do vetor normal ao plano tangente
		CVetN_Y,            // a um ponto da esfera.
		CVetN_Z,
		CVetL_X = -25,      // componentes do vetor da fonte luminosa.
		CVetL_Y = 18,
		CVetL_Z = 25,
		ProdEsc;            // produto escalar: a*c + b*d  para  (a,b) * (c,d)
	float
		ModuloVetN,         // comprimento do vetor normal (= ao raio).
		ModuloVetL = ( float ) sqrt ( Quadrado (CVetL_X) + Quadrado (CVetL_Y) + Quadrado (CVetL_Z) ),
		Angulo;             // angulo entre os vetores. Para definir brilho.

	for ( ContaY = -50; ContaY < 50; ContaY ++ )
		for ( ContaX = -50; ContaX < 50; ContaX ++ )
			if ( Delta ( ContaX, ContaY ) >= 0 )
				{
					CVetN_X = ContaX;
					CVetN_Y = ContaY;
					CVetN_Z = CalcZ ( ContaX, ContaY );
					ModuloVetN = ( float ) sqrt ( Quadrado (CVetN_X) + Quadrado (CVetN_Y) + Quadrado (CVetN_Z) );
					ProdEsc = CVetN_X * CVetL_X + CVetN_Y * CVetL_Y + CVetN_Z * CVetL_Z;
					Angulo = ( int ) ( acos ( ( float ) ProdEsc / ( ModuloVetN * ModuloVetL ) ) * 180 / M_PI );
					Cor = 64 + ( int ) Angulo / 3 + 16;
					putpixel ( ContaX + 320, ContaY + 240, Cor );
				}

	getch ();
	closegraph ();
}